package draw

import (
	"fmt"
	"io/ioutil"
	"os"
)

// SetLabel sets the host window's title.
func (d *Display) SetLabel(label string) {
	err := ioutil.WriteFile("/mnt/wsys/label", []byte(label), 0666)
	if err != nil {
		fmt.Fprintf(os.Stderr, "cannot set label: %v\n", err)
	}
}

// Top moves the host window to the top of the host window pile.
func (d *Display) Top() {
	err := ioutil.WriteFile("/mnt/wsys/wctl", []byte("top"), 0666)
	if err != nil {
		fmt.Fprintf(os.Stderr, "cannot move window to top: %v\n", err)
	}
}

// Resize resizes the host window.
func (d *Display) Resize(r Rectangle) {
	data := fmt.Sprintf("resize -dx %d -dy %d", r.Dx(), r.Dy())
	err := ioutil.WriteFile("/mnt/wsys/wctl", []byte(data), 0666)
	if err != nil {
		fmt.Fprintf(os.Stderr, "cannot resize window: %v\n", err)
	}
}
